<?php

namespace SM\Service;

use SM\Factory\TipoLocalAtendimento2Factory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class TipoLocalAtendimento2Service
{

    protected $TipoLocalAtendimento2Factory;
    protected $Environment;
    protected $newCode;


    public function __construct(EntityManager $entityManager, TipoLocalAtendimento2Factory $TipoLocalAtendimento2Factory, Environment $Environment, NewCode $newCode)
    {
        $this->TipoLocalAtendimento2Factory = $TipoLocalAtendimento2Factory;
        $this->connection                   = $entityManager->getConnection();
        $this->Environment                  = $Environment;
        $this->newCode                      = $newCode;
    }

    public function getTipoLocalAtendimento2()
    {
        return $this->TipoLocalAtendimento2Factory->getTipoLocalAtendimento2();
    }

    public function salvarTipoLocalAtendimento2($parametros)
    {
        $cdoperador = $this->Environment->getCdOperador();
        $NRORG = $this->Environment->getNrOrg();
        $this->connection->beginTransaction();
        try {
            foreach ($parametros as $classification) {
                if ($classification["NRTIPOESTRUTURA"] == 0) {
                    $NRTIPOESTRUTURA = $this->newCode->getCodeByTableName("TIPOESTRUTURA", $NRORG, 1, 10, true);
                    $dataParam = array(
                        "NRTIPOESTRUTURA" => $NRTIPOESTRUTURA,
                        "NMTIPOESTRUTURA"   => $classification["NMTIPOESTRUTURA"],
                        "NRORG"              => $NRORG,
                        "NRORGINCLUSAO"      => $NRORG,
                        "CDOPERINCLUSAO"     => $cdoperador,
                        "IDATIVO"            => "S",

                    );
                    $this->TipoLocalAtendimento2Factory->salvarTipoLocalAtendimento2($dataParam);
                } else {
                    $dataParam = array(
                        "NRTIPOESTRUTURA" => $classification["NRTIPOESTRUTURA"],
                        "NMTIPOESTRUTURA"  => $classification["NMTIPOESTRUTURA"],
                        "CDOPERULTATU"      => $cdoperador,
                        "NRORGULTATU"       => $NRORG,
                    );
                    $this->TipoLocalAtendimento2Factory->atualizarTipoLocalAtendimento2($dataParam);
                }
            }
            $this->connection->commit();
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }

    public function deletarTipoLocalAtendimento2($parametros)
    {
        $this->connection->beginTransaction();
        try {
            foreach ($parametros as $classification) {
                $dataParam = array("NRTIPOESTRUTURA" => $classification["NRTIPOESTRUTURA"],);
                $this->TipoLocalAtendimento2Factory->deletarTipoLocalAtendimento2($dataParam);
            }
            $this->connection->commit();
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }
}
