import { TekGrid } from '@zeedhi/teknisa-components-common';
import { Metadata, Http } from '@zeedhi/core';
import {
    LoadingService, TextInput, IGridEvent, DialogService,
} from '@zeedhi/common';
import { Utilities } from '@/util/Utilities';

export class TipoLocalAtendimento2Controller {
    public adicionarTipoLocalAtendimento2() {
        const grid = Metadata.getInstance<TekGrid>('tipo-local-atendimento-tek-grid2');
        // const newId = (grid.datasource.total + 1).toString();
        const newId = 0;

        grid.addNewRow({ NRTIPOESTRUTURA: newId }, 'start');
        setTimeout(() => {
            const nameInput = Metadata.getInstance<TextInput>(`NMTIPOESTRUTURA_editable_${newId}`);
            nameInput.setFocus();
        }, 100);
    }

    public async salvarTipoLocalAtendimento2({ event }: IGridEvent) {
        event!.preventDefault();
        const grid = Metadata.getInstance<TekGrid>('tipo-local-atendimento-tek-grid2');
        const classifications = grid.getEditedRows();
        LoadingService.show();
        try {
            await Http.post('/salvarTipoLocalAtendimento2', classifications);
            await grid.cancelEditedRows();
            await grid.reload();
            Utilities.showSuccessMessage();
        } catch (e) {
            Utilities.showErrorMessage(e);
        }
        LoadingService.hide();
    }

    public dialogDeletarTipoLocalAtendimento2({ event }: any) {
        Utilities.showConfirmDeleteMessage(event, 'TipoLocalAtendimento2Controller.deletarTipoLocalAtendimento2');
    }

    public deletarTipoLocalAtendimento2() {
        DialogService.hide();
        const grid = Metadata.getInstance<TekGrid>('tipo-local-atendimento-tek-grid2');
        LoadingService.show();
        Http.post('/deletarTipoLocalAtendimento2', grid.selectedRows).then(() => {
            grid.selectedRows = [];
            grid.cancelEditedRows();
            grid.reload();
            Utilities.showSuccessMessage();
        }).catch((error) => {
            Utilities.showErrorMessage(error);
        }).finally(() => {
            LoadingService.hide();
        });
    }

    private currentRow: any = {};

    private tekgridTipoLocalAtendimento2: boolean = true;

    get frameTipoLocalAtendimento2visible() {
        return !this.tekgridTipoLocalAtendimento2;
    }

    public abrirFrameTipoLocalAtendimento2({ row }: any) {
        this.tekgridTipoLocalAtendimento2 = false;
        this.currentRow = row;
        this.carregarDadosTipoLocalAtendimento2();
    }

    public carregarDadosTipoLocalAtendimento2() {
        Metadata.getInstance<TextInput>('NMTIPOESTRUTURA').value = this.currentRow.NMTIPOESTRUTURA;
    }

    get tituloFrameHabilidadePessoal() {
        return this.currentRow.NMTIPOESTRUTURA;
    }

    public backTekGridTipoLocalAtendimento2() {
        this.tekgridTipoLocalAtendimento2 = true;
        this.ativaTabDescricao();
    }

    public ativaTabDescricao() {
        this.adicionarTipoLocalAtendimento2();
    }
}
